diff a/src/hotspot/share/compiler/oopMap.hpp b/src/hotspot/share/compiler/oopMap.hpp
--- a/src/hotspot/share/compiler/oopMap.hpp
+++ b/src/hotspot/share/compiler/oopMap.hpp
@@ -152,10 +152,11 @@
 class OopMap: public ResourceObj {
   friend class OopMapStream;
   friend class VMStructs;
   friend class OopMapSet;
   friend class OopMapSort;
+  friend class SCCReader;
  private:
   int  _pc_offset; // offset in the code that this OopMap corresponds to
   int  _omv_count; // number of OopMapValues in the stream
   int  _num_oops;  // number of oops
   int  _index;     // index in OopMapSet
@@ -178,10 +179,11 @@
 
   void set_xxx(VMReg reg, OopMapValue::oop_types x, VMReg optional);
 
  public:
   OopMap(int frame_size, int arg_count);
+  OopMap(int data_size);
 
   // pc-offset handling
   int offset() const     { return _pc_offset; }
   void set_offset(int o) { _pc_offset = o; }
   int count() const { return _omv_count; }
@@ -214,17 +216,19 @@
   bool equals(const OopMap* other) const;
 };
 
 class OopMapSet : public ResourceObj {
   friend class VMStructs;
+  friend class SCCReader;
  private:
   GrowableArray<OopMap*> _list;
 
   int add(OopMap* value) { return _list.append(value); }
 
  public:
   OopMapSet();
+  OopMapSet(int size);
 
   // returns the number of OopMaps in this OopMapSet
   int size() const            { return _list.length(); }
   // returns the OopMap at a given index
   OopMap* at(int index) const { return _list.at(index); }
diff a/src/hotspot/share/compiler/precompiler.cpp b/src/hotspot/share/compiler/precompiler.cpp
--- /dev/null
+++ b/src/hotspot/share/compiler/precompiler.cpp
@@ -0,0 +1,247 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+#include "cds/archiveBuilder.hpp"
+#include "cds/cdsAccess.hpp"
+#include "cds/cdsConfig.hpp"
+#include "cds/runTimeClassInfo.hpp"
+#include "code/SCCache.hpp"
+#include "compiler/compiler_globals.hpp"
+#include "compiler/compileBroker.hpp"
+#include "compiler/precompiler.hpp"
+#include "logging/logStream.hpp"
+#include "memory/allocation.hpp"
+#include "oops/trainingData.hpp"
+#include "runtime/handles.inline.hpp"
+
+static int precompiled_total_count = 0;
+
+class PrecompileIterator : StackObj {
+private:
+  CompLevel _comp_level;
+  CompLevel _search_level;
+  bool _for_preload;
+  Thread* _thread;
+  GrowableArray<Method*> _methods;
+
+  bool precompile(Method* m, TRAPS) {
+    assert(!HAS_PENDING_EXCEPTION, "");
+    assert(m->method_holder()->is_linked(), "required");
+
+    ++precompiled_total_count;
+
+    uint entries_cnt_before = SCCache::store_entries_cnt();
+
+    methodHandle mh(THREAD, m);
+    CompileTask::CompileReason compile_reason = (_for_preload ? CompileTask::Reason_PrecompileForPreload
+                                                              : CompileTask::Reason_Precompile);
+    nmethod* nm = CompileBroker::compile_method(mh, InvocationEntryBci, _comp_level, methodHandle(), 0,
+                                                true /*requires_online_comp*/, compile_reason,
+                                                THREAD);
+
+    uint entries_cnt_after = SCCache::store_entries_cnt();
+
+    return (nm != nullptr) || (entries_cnt_after > entries_cnt_before);
+  }
+
+  bool precompile(Method* m, ArchiveBuilder* builder, TRAPS) {
+    bool status = precompile(m, THREAD);
+
+    LogStreamHandle(Info, precompile) log;
+    if (log.is_enabled()) {
+      ResourceMark rm;
+      log.print("[%4d] T%d Compiled %s [%p",
+                precompiled_total_count, _comp_level + (_for_preload ? 1 : 0), m->external_name(), m);
+      if (builder != nullptr) {
+        Method* requested_m = builder->to_requested(builder->get_buffered_addr(m));
+        log.print(" -> %p", requested_m);
+      }
+      log.print("] [%d] (%s)", SCCache::store_entries_cnt(), (status ? "success" : "FAILED"));
+    }
+    return status;
+  }
+
+public:
+  PrecompileIterator(CompLevel comp_level, bool for_preload, CompLevel search_level, JavaThread* thread)
+  : _comp_level(comp_level), _search_level(search_level), _for_preload(for_preload), _thread(thread) {
+    assert(TrainingData::have_data(), "sanity");
+  }
+
+  bool include(Method* m) {
+    if (m->is_native() || m->is_abstract()) {
+      return false;
+    }
+    DirectiveSet* directives = DirectivesStack::getMatchingDirective(methodHandle(_thread, m), nullptr);
+    if (directives->DontPrecompileOption) {
+      return false; // excluded
+    } else if (directives->PrecompileRecordedOption > 0) {
+      return true;
+    }
+    int cid = compile_id(m, _search_level);
+    return (cid < INT_MAX);
+  }
+
+  void do_value(const RunTimeClassInfo* record) {
+    Array<Method*>* methods = record->klass()->methods();
+    for (int i = 0; i < methods->length(); i++) {
+      Method* m = methods->at(i);
+      if (include(m)) {
+        _methods.push(m);
+      }
+    }
+  }
+  void do_value(TrainingData* td) {
+    if (td->is_MethodTrainingData()) {
+      MethodTrainingData* mtd = td->as_MethodTrainingData();
+      if (mtd->has_holder() && include((Method*)mtd->holder())) {
+        _methods.push((Method*)mtd->holder());
+      }
+    }
+  }
+
+  static int compile_id(Method* m, int level) {
+    MethodTrainingData* mtd = TrainingData::lookup_for(m);
+    if (mtd != nullptr && mtd->highest_level() == level) {
+      CompileTrainingData* ctd = mtd->last_toplevel_compile(level);
+      if (ctd != nullptr) {
+        return ctd->compile_id();
+      }
+    }
+    return INT_MAX; // treat as the last compilation
+  }
+
+  static int compare_by_compile_id(Method** m1, Method** m2, CompLevel comp_level) {
+    int id1 = compile_id(*m1, comp_level);
+    int id2 = compile_id(*m2, comp_level);
+    return (id1 - id2);
+  }
+
+  static int compare_by_compile_id_tier1(Method** m1, Method** m2) {
+    return compare_by_compile_id(m1, m2, CompLevel_simple);
+  }
+
+  static int compare_by_compile_id_tier2(Method** m1, Method** m2) {
+    return compare_by_compile_id(m1, m2, CompLevel_limited_profile);
+  }
+
+  static int compare_by_compile_id_tier3(Method** m1, Method** m2) {
+    return compare_by_compile_id(m1, m2, CompLevel_full_profile);
+  }
+
+  static int compare_by_compile_id_tier4(Method** m1, Method** m2) {
+    return compare_by_compile_id(m1, m2, CompLevel_full_optimization);
+  }
+
+  void sort_methods_by_compile_id(GrowableArray<Method*>* methods) {
+    switch(_search_level) {
+      case CompLevel_simple:            methods->sort(&compare_by_compile_id_tier1); break;
+      case CompLevel_limited_profile:   methods->sort(&compare_by_compile_id_tier2); break;
+      case CompLevel_full_profile:      methods->sort(&compare_by_compile_id_tier3); break;
+      case CompLevel_full_optimization: methods->sort(&compare_by_compile_id_tier4); break;
+
+      default: fatal("%d", _search_level);
+    }
+  }
+
+  void precompile(ArchiveBuilder* builder, TRAPS) {
+    sort_methods_by_compile_id(&_methods);
+
+    for (int i = 0; i < _methods.length(); i++) {
+      Method* m = _methods.at(i);
+
+      assert(!HAS_PENDING_EXCEPTION, "");
+      precompile(m, builder, THREAD);
+      if (HAS_PENDING_EXCEPTION) {
+        CLEAR_PENDING_EXCEPTION;
+      }
+    }
+  }
+};
+void Precompiler::compile_cached_code(CompLevel search_level, bool for_preload, CompLevel comp_level, TRAPS) {
+  ResourceMark rm;
+  PrecompileIterator pi(comp_level, for_preload, search_level, THREAD);
+  TrainingData::archived_training_data_dictionary()->iterate(&pi);
+  pi.precompile((ArchiveBuilder*)nullptr, THREAD);
+}
+
+void Precompiler::compile_cached_code(TRAPS) {
+  log_info(precompile)("Precompilation started");
+  if (TrainingData::have_data()) {
+    TrainingData::archived_training_data_dictionary()->iterate([&](TrainingData* td) {
+      if (td->is_KlassTrainingData()) {
+        KlassTrainingData *ktd = td->as_KlassTrainingData();
+        if (ktd->has_holder()) {
+          assert(!HAS_PENDING_EXCEPTION, "");
+          ktd->holder()->link_class(THREAD);
+          if (HAS_PENDING_EXCEPTION) {
+            LogStreamHandle(Warning, precompile) log;
+            if (log.is_enabled()) {
+              ResourceMark rm;
+              log.print("Linkage failed for %s: ", ktd->holder()->external_name());
+              PENDING_EXCEPTION->print_on(&log);
+            }
+            CLEAR_PENDING_EXCEPTION;
+          }
+        }
+      }
+    });
+
+    compile_cached_code(CompLevel_full_optimization, true, CompLevel_full_optimization, CHECK);
+
+    compile_cached_code(CompLevel_full_optimization, false, CompLevel_full_optimization, CHECK);
+    compile_cached_code(CompLevel_full_profile,      false, CompLevel_limited_profile,   CHECK);
+    compile_cached_code(CompLevel_limited_profile,   false, CompLevel_limited_profile,   CHECK);
+    compile_cached_code(CompLevel_simple,            false, CompLevel_simple,            CHECK);
+  }
+  log_info(precompile)("Precompilation finished (total: %d)", precompiled_total_count);
+}
+
+// New workflow only
+void Precompiler::compile_cached_code(ArchiveBuilder* builder, TRAPS) {
+  assert(CDSConfig::is_dumping_final_static_archive() && StoreCachedCode, "sanity");
+  if (TrainingData::have_data()) {
+    ResourceMark rm;
+
+    SCCache::new_workflow_start_writing_cache();
+
+    {
+      PrecompileIterator pi(CompLevel_full_optimization, true /*for_preload*/, CompLevel_full_optimization, THREAD);
+      TrainingData::archived_training_data_dictionary()->iterate(&pi);
+      pi.precompile(builder, THREAD);
+    }
+
+    for (int level = CompLevel_simple; level <= CompLevel_full_optimization; level++) {
+      CompLevel comp_level = (CompLevel)level;
+      if (comp_level == CompLevel_full_profile) {
+        comp_level = CompLevel_limited_profile;
+      }
+      PrecompileIterator pi(comp_level, false /*for_preload*/, (CompLevel)level, THREAD);
+      TrainingData::archived_training_data_dictionary()->iterate(&pi);
+      pi.precompile(builder, THREAD);
+    }
+
+    SCCache::new_workflow_end_writing_cache();
+  }
+}
diff a/src/hotspot/share/compiler/precompiler.hpp b/src/hotspot/share/compiler/precompiler.hpp
--- /dev/null
+++ b/src/hotspot/share/compiler/precompiler.hpp
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_COMPILER_PRECOMPILER_HPP
+#define SHARE_COMPILER_PRECOMPILER_HPP
+
+#include "memory/allStatic.hpp"
+#include "utilities/exceptions.hpp"
+
+class ArchiveBuilder;
+
+class Precompiler : AllStatic  {
+private:
+  static int _total_count;
+
+public:
+  static void compile_cached_code(CompLevel search_level, bool for_preload, CompLevel comp_level, TRAPS);
+  static void compile_cached_code(TRAPS);
+  static void compile_cached_code(ArchiveBuilder* builder, TRAPS);
+};
+
+#endif // SHARE_COMPILER_PRECOMPILER_HPP
diff a/src/hotspot/share/compiler/recompilationPolicy.cpp b/src/hotspot/share/compiler/recompilationPolicy.cpp
--- /dev/null
+++ b/src/hotspot/share/compiler/recompilationPolicy.cpp
@@ -0,0 +1,118 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+#include "compiler/compilationPolicy.hpp"
+#include "compiler/recompilationPolicy.hpp"
+#include "oops/method.inline.hpp"
+#include "oops/recompilationSchedule.hpp"
+#include "runtime/handles.inline.hpp"
+
+RecompilationPolicy::LoadAverage RecompilationPolicy::_load_average;
+volatile bool RecompilationPolicy::_recompilation_done = false;
+
+void RecompilationPolicy::sample_load_average() {
+  if (UseRecompilation) {
+    const int c2_queue_size = CompileBroker::queue_size(CompLevel_full_optimization);
+    _load_average.sample(c2_queue_size);
+  }
+}
+
+void RecompilationPolicy::print_load_average() {
+  tty->print(" load=%lf", _load_average.value());
+}
+
+bool RecompilationPolicy::have_recompilation_work() {
+  if (UseRecompilation && TrainingData::have_data() && RecompilationSchedule::have_schedule() &&
+                          RecompilationSchedule::length() > 0 && !_recompilation_done) {
+    if (_load_average.value() <= RecompilationLoadAverageThreshold) {
+      return true;
+    }
+  }
+  return false;
+}
+
+bool RecompilationPolicy::recompilation_step(int step, TRAPS) {
+  if (!have_recompilation_work() || os::elapsedTime() < DelayRecompilation) {
+    return false;
+  }
+
+  const int size = RecompilationSchedule::length();
+  int i = 0;
+  int count = 0;
+  bool repeat = false;
+  for (; i < size && count < step; i++) {
+    if (!RecompilationSchedule::status_at(i)) {
+      MethodTrainingData* mtd = RecompilationSchedule::at(i);
+      if (!mtd->has_holder()) {
+        RecompilationSchedule::set_status_at(i, true);
+        continue;
+      }
+      const Method* method = mtd->holder();
+      InstanceKlass* klass = method->method_holder();
+      if (klass->is_not_initialized()) {
+        repeat = true;
+        continue;
+      }
+      nmethod *nm = method->code();
+      if (nm == nullptr) {
+        repeat = true;
+        continue;
+      }
+
+      if (!ForceRecompilation && !(nm->is_scc() && nm->comp_level() == CompLevel_full_optimization)) {
+        // If it's already online-compiled at level 4, mark it as done.
+        if (nm->comp_level() == CompLevel_full_optimization) {
+          RecompilationSchedule::set_status_at(i, true);
+        } else {
+          repeat = true;
+        }
+        continue;
+      }
+      if (RecompilationSchedule::claim_at(i)) {
+        const methodHandle m(THREAD, const_cast<Method*>(method));
+        CompLevel next_level = CompLevel_full_optimization;
+
+        if (method->method_data() == nullptr) {
+          CompilationPolicy::create_mdo(m, THREAD);
+        }
+
+        if (PrintTieredEvents) {
+          CompilationPolicy::print_event(CompilationPolicy::FORCE_RECOMPILE, m(), m(), InvocationEntryBci, next_level);
+        }
+        CompileBroker::compile_method(m, InvocationEntryBci, CompLevel_full_optimization, methodHandle(), 0,
+                                      true /*requires_online_compilation*/, CompileTask::Reason_MustBeCompiled, THREAD);
+        if (HAS_PENDING_EXCEPTION) {
+          CLEAR_PENDING_EXCEPTION;
+        }
+        count++;
+      }
+    }
+  }
+
+  if (i == size && !repeat) {
+    Atomic::release_store(&_recompilation_done, true);
+  }
+  return count > 0;
+}
diff a/src/hotspot/share/compiler/recompilationPolicy.hpp b/src/hotspot/share/compiler/recompilationPolicy.hpp
--- /dev/null
+++ b/src/hotspot/share/compiler/recompilationPolicy.hpp
@@ -0,0 +1,95 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_COMPILER_RECOMPILATIONPOLICY_HPP
+#define SHARE_COMPILER_RECOMPILATIONPOLICY_HPP
+
+#include "compiler/compileBroker.hpp"
+#include "memory/allStatic.hpp"
+#include "utilities/globalDefinitions.hpp"
+
+namespace CompilationPolicyUtils {
+template<int SAMPLE_COUNT = 256>
+class WeightedMovingAverage {
+  int _current;
+  int _samples[SAMPLE_COUNT];
+  int64_t _timestamps[SAMPLE_COUNT];
+
+  void sample(int s, int64_t t) {
+    assert(s >= 0, "Negative sample values are not supported");
+    _samples[_current] = s;
+    _timestamps[_current] = t;
+    if (++_current >= SAMPLE_COUNT) {
+      _current = 0;
+    }
+  }
+
+  // Since sampling happens at irregular invervals the solution is to
+  // discount the older samples proportionally to the time between
+  // the now and the time of the sample.
+  double value(int64_t t) const {
+    double decay_speed = 1;
+    double weighted_sum = 0;
+    int count = 0;
+    for (int i = 0; i < SAMPLE_COUNT; i++) {
+      if (_samples[i] >= 0) {
+        count++;
+        double delta_t = (t - _timestamps[i]) / 1000.0; // in seconds
+        if (delta_t < 1) delta_t = 1;
+        weighted_sum += (double) _samples[i] / (delta_t * decay_speed);
+      }
+    }
+    if (count > 0) {
+      return weighted_sum / count;
+    } else {
+      return 0;
+    }
+  }
+  static int64_t time() {
+    return nanos_to_millis(os::javaTimeNanos());
+  }
+public:
+  WeightedMovingAverage() : _current(0) {
+    for (int i = 0; i < SAMPLE_COUNT; i++) {
+      _samples[i] = -1;
+    }
+  }
+  void sample(int s) { sample(s, time()); }
+  double value() const { return value(time()); }
+};
+} // namespace CompilationPolicyUtils
+
+
+class RecompilationPolicy : AllStatic {
+  typedef CompilationPolicyUtils::WeightedMovingAverage<> LoadAverage;
+  static LoadAverage _load_average;
+  static volatile bool _recompilation_done;
+public:
+  static void sample_load_average();
+  static void print_load_average();
+  static bool have_recompilation_work();
+  static bool recompilation_step(int step, TRAPS);
+};
+
+#endif // SHARE_COMPILER_RECOMPILATIONPOLICY_HPP
diff a/src/hotspot/share/gc/g1/c1/g1BarrierSetC1.cpp b/src/hotspot/share/gc/g1/c1/g1BarrierSetC1.cpp
--- a/src/hotspot/share/gc/g1/c1/g1BarrierSetC1.cpp
+++ b/src/hotspot/share/gc/g1/c1/g1BarrierSetC1.cpp
@@ -23,10 +23,13 @@
  */
 
 #include "precompiled.hpp"
 #include "c1/c1_LIRGenerator.hpp"
 #include "c1/c1_CodeStubs.hpp"
+#if INCLUDE_CDS
+#include "code/SCCache.hpp"
+#endif
 #include "gc/g1/c1/g1BarrierSetC1.hpp"
 #include "gc/g1/g1BarrierSet.hpp"
 #include "gc/g1/g1BarrierSetAssembler.hpp"
 #include "gc/g1/g1HeapRegion.hpp"
 #include "gc/g1/g1ThreadLocalData.hpp"
@@ -151,24 +154,61 @@
   }
   assert(addr->is_register(), "must be a register at this point");
 
   LIR_Opr xor_res = gen->new_pointer_register();
   LIR_Opr xor_shift_res = gen->new_pointer_register();
+#if INCLUDE_CDS
+  // we need to load the grain shift from the AOT Runtime
+  // Constants Area
+  LIR_Opr grain_shift_addr = LIR_OprFact::intptrConst(AOTRuntimeConstants::grain_shift_address());
+  LIR_Opr grain_shift_reg = gen->new_pointer_register();
+  LIR_Address* grain_shift_indirect = new LIR_Address(grain_shift_reg, 0, T_INT);
+#ifdef X86
+  LIR_Opr grain_shift = gen->shiftCountOpr();
+#else // X86
+  LIR_Opr grain_shift = gen->new_register(T_INT);
+#endif // X86
+#endif
   if (two_operand_lir_form) {
     __ move(addr, xor_res);
     __ logical_xor(xor_res, new_val, xor_res);
-    __ move(xor_res, xor_shift_res);
-    __ unsigned_shift_right(xor_shift_res,
-                            LIR_OprFact::intConst(checked_cast<jint>(G1HeapRegion::LogOfHRGrainBytes)),
-                            xor_shift_res,
-                            LIR_Opr::illegalOpr());
+#if INCLUDE_CDS
+    if (SCCache::is_on_for_write()) {
+      __ move(grain_shift_addr, grain_shift_reg);
+      __ move(xor_res, xor_shift_res);
+      __ move(grain_shift_indirect, grain_shift);
+      __ unsigned_shift_right(xor_shift_res,
+                              grain_shift,
+                              xor_shift_res,
+                              LIR_Opr::illegalOpr());
+    } else
+#endif
+    {
+      __ move(xor_res, xor_shift_res);
+      __ unsigned_shift_right(xor_shift_res,
+                              LIR_OprFact::intConst(checked_cast<jint>(G1HeapRegion::LogOfHRGrainBytes)),
+                              xor_shift_res,
+                              LIR_Opr::illegalOpr());
+    }
   } else {
     __ logical_xor(addr, new_val, xor_res);
-    __ unsigned_shift_right(xor_res,
-                            LIR_OprFact::intConst(checked_cast<jint>(G1HeapRegion::LogOfHRGrainBytes)),
-                            xor_shift_res,
-                            LIR_Opr::illegalOpr());
+#if INCLUDE_CDS
+    if (SCCache::is_on_for_write()) {
+      __ move(grain_shift_addr, grain_shift_reg);
+      __ move(grain_shift_indirect, grain_shift);
+      __ unsigned_shift_right(xor_res,
+                              grain_shift,
+                              xor_shift_res,
+                              LIR_Opr::illegalOpr());
+    } else
+#endif
+    {
+      __ unsigned_shift_right(xor_res,
+                              LIR_OprFact::intConst(checked_cast<jint>(G1HeapRegion::LogOfHRGrainBytes)),
+                              xor_shift_res,
+                              LIR_Opr::illegalOpr());
+    }
   }
 
   __ cmp(lir_cond_notEqual, xor_shift_res, LIR_OprFact::intptrConst(NULL_WORD));
 
   CodeStub* slow = new G1PostBarrierStub(addr, new_val);
diff a/src/hotspot/share/gc/g1/c2/g1BarrierSetC2.cpp b/src/hotspot/share/gc/g1/c2/g1BarrierSetC2.cpp
--- a/src/hotspot/share/gc/g1/c2/g1BarrierSetC2.cpp
+++ b/src/hotspot/share/gc/g1/c2/g1BarrierSetC2.cpp
@@ -22,10 +22,13 @@
  *
  */
 
 #include "precompiled.hpp"
 #include "classfile/javaClasses.hpp"
+#if INCLUDE_CDS
+#include "code/SCCache.hpp"
+#endif
 #include "code/vmreg.inline.hpp"
 #include "gc/g1/c2/g1BarrierSetC2.hpp"
 #include "gc/g1/g1BarrierSet.hpp"
 #include "gc/g1/g1BarrierSetAssembler.hpp"
 #include "gc/g1/g1BarrierSetRuntime.hpp"
diff a/src/hotspot/share/gc/g1/g1BarrierSet.hpp b/src/hotspot/share/gc/g1/g1BarrierSet.hpp
--- a/src/hotspot/share/gc/g1/g1BarrierSet.hpp
+++ b/src/hotspot/share/gc/g1/g1BarrierSet.hpp
@@ -24,10 +24,11 @@
 
 #ifndef SHARE_GC_G1_G1BARRIERSET_HPP
 #define SHARE_GC_G1_G1BARRIERSET_HPP
 
 #include "gc/g1/g1DirtyCardQueue.hpp"
+#include "gc/g1/g1HeapRegion.hpp"
 #include "gc/g1/g1SATBMarkQueueSet.hpp"
 #include "gc/shared/cardTable.hpp"
 #include "gc/shared/cardTableBarrierSet.hpp"
 #include "gc/shared/bufferNode.hpp"
 
@@ -89,10 +90,12 @@
 
   static G1DirtyCardQueueSet& dirty_card_queue_set() {
     return g1_barrier_set()->_dirty_card_queue_set;
   }
 
+  virtual uint grain_shift() { return G1HeapRegion::LogOfHRGrainBytes; }
+
   // Callbacks for runtime accesses.
   template <DecoratorSet decorators, typename BarrierSetT = G1BarrierSet>
   class AccessBarrier: public ModRefBarrierSet::AccessBarrier<decorators, BarrierSetT> {
     typedef ModRefBarrierSet::AccessBarrier<decorators, BarrierSetT> ModRef;
     typedef BarrierSet::AccessBarrier<decorators, BarrierSetT> Raw;
diff a/src/hotspot/share/gc/shared/barrierSetNMethod.cpp b/src/hotspot/share/gc/shared/barrierSetNMethod.cpp
--- a/src/hotspot/share/gc/shared/barrierSetNMethod.cpp
+++ b/src/hotspot/share/gc/shared/barrierSetNMethod.cpp
@@ -176,10 +176,11 @@
   assert(cb != nullptr, "invariant");
 
   nmethod* nm = cb->as_nmethod();
   BarrierSetNMethod* bs_nm = BarrierSet::barrier_set()->barrier_set_nmethod();
 
+  log_trace(nmethod, barrier)("Running nmethod entry barrier: %d " PTR_FORMAT, nm->compile_id(), p2i(nm));
   // Called upon first entry after being armed
   bool may_enter = bs_nm->nmethod_entry_barrier(nm);
   assert(!nm->is_osr_method() || may_enter, "OSR nmethods should always be entrant after migration");
 
   // In case a concurrent thread disarmed the nmethod, we need to ensure the new instructions
@@ -197,19 +198,24 @@
     if (Atomic::add(&counter, 1u) % 10 == 0) {
       may_enter = false;
     }
   }
 
-  if (!may_enter) {
+  if (may_enter) {
+    nm->set_used();
+  } else {
     log_trace(nmethod, barrier)("Deoptimizing nmethod: " PTR_FORMAT, p2i(nm));
     bs_nm->deoptimize(nm, return_address_ptr);
   }
   return may_enter ? 0 : 1;
 }
 
 bool BarrierSetNMethod::nmethod_osr_entry_barrier(nmethod* nm) {
   assert(nm->is_osr_method(), "Should not reach here");
-  log_trace(nmethod, barrier)("Running osr nmethod entry barrier: " PTR_FORMAT, p2i(nm));
+  log_trace(nmethod, barrier)("Running osr nmethod entry barrier: %d " PTR_FORMAT, nm->compile_id(), p2i(nm));
   bool result = nmethod_entry_barrier(nm);
+  if (result) {
+    nm->set_used();
+  }
   OrderAccess::cross_modify_fence();
   return result;
 }
diff a/src/hotspot/share/gc/shared/cardTableBarrierSet.hpp b/src/hotspot/share/gc/shared/cardTableBarrierSet.hpp
--- a/src/hotspot/share/gc/shared/cardTableBarrierSet.hpp
+++ b/src/hotspot/share/gc/shared/cardTableBarrierSet.hpp
@@ -104,10 +104,15 @@
 
   virtual void make_parsable(JavaThread* thread) { flush_deferred_card_mark_barrier(thread); }
 
   virtual void print_on(outputStream* st) const;
 
+  // The AOT code cache manager needs to know the current card shift
+  // and, for some barrier sets, the region grain size shift
+  uint card_shift() const { return _card_table->card_shift(); }
+  virtual uint grain_shift() { return 0; }
+
   template <DecoratorSet decorators, typename BarrierSetT = CardTableBarrierSet>
   class AccessBarrier: public ModRefBarrierSet::AccessBarrier<decorators, BarrierSetT> {};
 };
 
 template<>
diff a/src/hotspot/share/gc/shared/collectorCounters.cpp b/src/hotspot/share/gc/shared/collectorCounters.cpp
--- a/src/hotspot/share/gc/shared/collectorCounters.cpp
+++ b/src/hotspot/share/gc/shared/collectorCounters.cpp
@@ -65,11 +65,11 @@
 CollectorCounters::~CollectorCounters() {
   FREE_C_HEAP_ARRAY(char, _name_space);
 }
 
 TraceCollectorStats::TraceCollectorStats(CollectorCounters* c) :
-    PerfTraceTimedEvent(c->time_counter(), c->invocation_counter()),
+    PerfTraceElapsedTimeEvent(c->time_counter(), c->invocation_counter()),
     _c(c) {
 
   if (UsePerfData) {
      _c->last_entry_counter()->set_value(os::elapsed_counter());
   }
diff a/src/hotspot/share/gc/shared/collectorCounters.hpp b/src/hotspot/share/gc/shared/collectorCounters.hpp
--- a/src/hotspot/share/gc/shared/collectorCounters.hpp
+++ b/src/hotspot/share/gc/shared/collectorCounters.hpp
@@ -60,11 +60,11 @@
     inline PerfVariable* last_exit_counter() const  { return _last_exit_time; }
 
     const char* name_space() const                  { return _name_space; }
 };
 
-class TraceCollectorStats: public PerfTraceTimedEvent {
+class TraceCollectorStats: public PerfTraceElapsedTimeEvent {
 
   protected:
     CollectorCounters* _c;
 
   public:
diff a/src/hotspot/share/gc/shenandoah/c1/shenandoahBarrierSetC1.hpp b/src/hotspot/share/gc/shenandoah/c1/shenandoahBarrierSetC1.hpp
--- a/src/hotspot/share/gc/shenandoah/c1/shenandoahBarrierSetC1.hpp
+++ b/src/hotspot/share/gc/shenandoah/c1/shenandoahBarrierSetC1.hpp
@@ -187,11 +187,14 @@
     return "shenandoah_cas_obj";
   }
 #endif // PRODUCT
 };
 
+class SCAddressTable;
+
 class ShenandoahBarrierSetC1 : public BarrierSetC1 {
+  friend class SCAddressTable;
 private:
   CodeBlob* _pre_barrier_c1_runtime_code_blob;
   CodeBlob* _load_reference_barrier_strong_rt_code_blob;
   CodeBlob* _load_reference_barrier_strong_native_rt_code_blob;
   CodeBlob* _load_reference_barrier_weak_rt_code_blob;
diff a/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp b/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
--- a/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
+++ b/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
@@ -85,11 +85,14 @@
 #ifndef PRODUCT
   virtual void print_name(outputStream* out) const;
 #endif // PRODUCT
 };
 
+class SCAddressTable;
+
 class ZBarrierSetC1 : public BarrierSetC1 {
+  friend SCAddressTable;
 private:
   address _load_barrier_on_oop_field_preloaded_runtime_stub;
   address _load_barrier_on_weak_oop_field_preloaded_runtime_stub;
   address _store_barrier_on_oop_field_with_healing;
   address _store_barrier_on_oop_field_without_healing;
diff a/src/hotspot/share/include/cds.h b/src/hotspot/share/include/cds.h
--- a/src/hotspot/share/include/cds.h
+++ b/src/hotspot/share/include/cds.h
@@ -33,15 +33,15 @@
 // We should use only standard C types. Do not use custom types such as bool, intx,
 // etc, to avoid introducing unnecessary dependencies to other HotSpot type declarations.
 //
 // Also, this is a C header file. Do not use C++ here.
 
-#define NUM_CDS_REGIONS 4 // this must be the same as MetaspaceShared::n_regions
+#define NUM_CDS_REGIONS 5 // this must be the same as MetaspaceShared::n_regions
 #define CDS_ARCHIVE_MAGIC 0xf00baba2
 #define CDS_DYNAMIC_ARCHIVE_MAGIC 0xf00baba8
 #define CDS_GENERIC_HEADER_SUPPORTED_MIN_VERSION 13
-#define CURRENT_CDS_ARCHIVE_VERSION 18
+#define CURRENT_CDS_ARCHIVE_VERSION 19
 
 typedef struct CDSFileMapRegion {
   int     _crc;               // CRC checksum of this region.
   int     _read_only;         // read only region?
   int     _allow_exec;        // executable code in this region?
